<?xml version="1.0"?>

<!DOCTYPE MODE SYSTEM "xmode.dtd">

<!-- Copyright (C) 2005 Lehrstuhl Grafische Systeme, BTU Cottbus -->
<!-- Based on jEdit's java.xml                                   -->

<MODE>
	<PROPS>
		<PROPERTY NAME="commentStart" VALUE="/*" />
		<PROPERTY NAME="commentEnd" VALUE="*/" />
		<PROPERTY NAME="lineComment" VALUE="//" />
		<PROPERTY NAME="wordBreakChars" VALUE=",+-=&lt;&gt;/?^&amp;*" />

		<!-- Auto indent -->
		<PROPERTY NAME="indentOpenBrackets" VALUE="{[" />
		<PROPERTY NAME="indentCloseBrackets" VALUE="}]" />
		<PROPERTY NAME="indentNextLine"
			VALUE="\s*(((if|while)\s*\(|else\s*|else\s+if\s*\(|for\s*\(.*\))[^{;]*)" />
		<!-- set this to 'true' if you want to use GNU coding style -->
		<PROPERTY NAME="doubleBracketIndent" VALUE="false" />
		<PROPERTY NAME="lineUpClosingBracket" VALUE="true" />
	</PROPS>
	<RULES ESCAPE="\"
		IGNORE_CASE="FALSE"
		HIGHLIGHT_DIGITS="TRUE"
		DIGIT_RE="(0x[[:xdigit:]]+[lL]?|[[:digit:]]+(e[[:digit:]]*)?[lLdDfF]?)">

		<!-- Silly comment -->
		<SEQ TYPE="COMMENT1">/**/</SEQ>

		<!-- Javadoc comment -->
		<SPAN TYPE="COMMENT3" DELEGATE="JAVADOC">
			<BEGIN>/**</BEGIN>
			<END>*/</END>
		</SPAN>

		<!-- Java comment (C style) -->
		<SPAN TYPE="COMMENT1">
			<BEGIN>/*</BEGIN>
			<END>*/</END>
		</SPAN>

		<SPAN TYPE="LITERAL1" NO_LINE_BREAK="TRUE">
			<BEGIN>"</BEGIN>
			<END>"</END>
		</SPAN>
		<SPAN TYPE="LITERAL1" NO_LINE_BREAK="TRUE">
			<BEGIN>'</BEGIN>
			<END>'</END>
		</SPAN>

		<EOL_SPAN TYPE="COMMENT2">//</EOL_SPAN>

		<SEQ TYPE="OPERATOR">=</SEQ>
		<SEQ TYPE="OPERATOR">!</SEQ>
		<SEQ TYPE="OPERATOR">&gt;=</SEQ>
		<SEQ TYPE="OPERATOR">&lt;=</SEQ>
		<SEQ TYPE="OPERATOR">+</SEQ>
		<SEQ TYPE="OPERATOR">-</SEQ>
		<SEQ TYPE="OPERATOR">/</SEQ>

		<!-- workaround to stop "*" from being colorized
		     in import statements. -->
		<SEQ TYPE="NULL">.*</SEQ>

		<SEQ TYPE="OPERATOR">*</SEQ>
		<SEQ TYPE="OPERATOR">&gt;</SEQ>
		<SEQ TYPE="OPERATOR">&lt;</SEQ>
		<SEQ TYPE="OPERATOR">%</SEQ>
		<SEQ TYPE="OPERATOR">&amp;</SEQ>
		<SEQ TYPE="OPERATOR">|</SEQ>
		<SEQ TYPE="OPERATOR">^</SEQ>
		<SEQ TYPE="OPERATOR">~</SEQ>
		<SEQ TYPE="OPERATOR">}</SEQ>
		<SEQ TYPE="OPERATOR">{</SEQ>
		<MARK_PREVIOUS TYPE="LABEL" MATCH_TYPE="OPERATOR"
			AT_WHITESPACE_END="TRUE">:</MARK_PREVIOUS>

		<!-- Function calls -->
		<MARK_PREVIOUS TYPE="FUNCTION" MATCH_TYPE="OPERATOR">(</MARK_PREVIOUS>

		<!-- Annotation types -->
		<MARK_FOLLOWING TYPE="KEYWORD4">@</MARK_FOLLOWING>

		<KEYWORDS>
			<KEYWORD1>abstract</KEYWORD1>
			<KEYWORD1>break</KEYWORD1>
			<KEYWORD1>case</KEYWORD1>
			<KEYWORD1>catch</KEYWORD1>
			<KEYWORD1>continue</KEYWORD1>
			<KEYWORD1>default</KEYWORD1>
			<KEYWORD1>do</KEYWORD1>
			<KEYWORD1>else</KEYWORD1>
			<KEYWORD1>extends</KEYWORD1>
			<KEYWORD1>final</KEYWORD1>
			<KEYWORD1>finally</KEYWORD1>
			<KEYWORD1>for</KEYWORD1>
			<KEYWORD1>if</KEYWORD1>
			<KEYWORD1>implements</KEYWORD1>
			<KEYWORD1>instanceof</KEYWORD1>
			<KEYWORD1>native</KEYWORD1>
			<KEYWORD1>new</KEYWORD1>
			<KEYWORD1>private</KEYWORD1>
			<KEYWORD1>protected</KEYWORD1>
			<KEYWORD1>public</KEYWORD1>
			<KEYWORD1>return</KEYWORD1>
			<KEYWORD1>static</KEYWORD1>
			<KEYWORD1>switch</KEYWORD1>
			<KEYWORD1>synchronized</KEYWORD1>
			<KEYWORD1>throw</KEYWORD1>
			<KEYWORD1>throws</KEYWORD1>
			<KEYWORD1>transient</KEYWORD1>
			<KEYWORD1>try</KEYWORD1>
			<KEYWORD1>volatile</KEYWORD1>
			<KEYWORD1>while</KEYWORD1>

			<KEYWORD2>package</KEYWORD2>
			<KEYWORD2>import</KEYWORD2>

			<KEYWORD3>boolean</KEYWORD3>
			<KEYWORD3>byte</KEYWORD3>
			<KEYWORD3>char</KEYWORD3>
			<KEYWORD3>class</KEYWORD3>
			<KEYWORD3>double</KEYWORD3>
			<KEYWORD3>float</KEYWORD3>
			<KEYWORD3>int</KEYWORD3>
			<KEYWORD3>interface</KEYWORD3>
			<KEYWORD3>long</KEYWORD3>
			<KEYWORD3>short</KEYWORD3>
			<KEYWORD3>void</KEYWORD3>

			<FUNCTION>assert</FUNCTION>
			<KEYWORD1>strictfp</KEYWORD1>


			<LITERAL2>false</LITERAL2>
			<LITERAL2>null</LITERAL2>
			<LITERAL2>super</LITERAL2>
			<LITERAL2>this</LITERAL2>
			<LITERAL2>true</LITERAL2>

			<INVALID>goto</INVALID>

			<!-- Java 1.5 -->
			<KEYWORD3>enum</KEYWORD3>

            <!-- XL -->
            <SEQ TYPE="OPERATOR">:'=</SEQ>
            <SEQ TYPE="OPERATOR">:+=</SEQ>
            <SEQ TYPE="OPERATOR">:-=</SEQ>
            <SEQ TYPE="OPERATOR">:*=</SEQ>
            <SEQ TYPE="OPERATOR">:/=</SEQ>
            
			<KEYWORD1>const</KEYWORD1>
			<KEYWORD1>in</KEYWORD1>
			<KEYWORD1>yield</KEYWORD1>
			<KEYWORD3>module</KEYWORD3>
			<KEYWORD3>scaleclass</KEYWORD3>

		</KEYWORDS>
	</RULES>

	<RULES SET="JAVADOC" DEFAULT="COMMENT3" IGNORE_CASE="TRUE">
		<!-- so that @link{...} is highlighted -->
		<SEQ TYPE="COMMENT3">{</SEQ>

		<!-- so that *@param is highlighted -->
		<SEQ TYPE="COMMENT3">*</SEQ>

		<!-- Javadoc ignores tags inside <pre> -->
		<!-- XXX no it doesn't -->
		<!-- SPAN TYPE="MARKUP" DELEGATE="JAVADOC_PRE">
			<BEGIN>&lt;pre&gt;</BEGIN>
			<END>&lt;/pre&gt;</END>
		</SPAN -->

		<!-- HTML comments -->
		<SPAN TYPE="COMMENT1">
			<BEGIN>&lt;!--</BEGIN>
			<END>--&gt;</END>
		</SPAN>

		<!-- Javadoc allows this -->
		<SEQ TYPE="COMMENT3">&lt;&lt;</SEQ>
		<SEQ TYPE="COMMENT3">&lt;=</SEQ>
		<SEQ TYPE="COMMENT3">&lt; </SEQ>

		<!-- HTML tags -->
		<SPAN TYPE="MARKUP" DELEGATE="xml::TAGS"
			NO_LINE_BREAK="TRUE">
			<BEGIN>&lt;</BEGIN>
			<END>&gt;</END>
		</SPAN>

		<KEYWORDS>
			<LABEL>@author</LABEL>
			<LABEL>@beaninfo</LABEL>
			<LABEL>@history</LABEL>
			<LABEL>@bug</LABEL>
			<LABEL>@review</LABEL>
			<LABEL>@todo</LABEL>
			<LABEL>@idea</LABEL>
			<LABEL>@pre</LABEL>
			<LABEL>@requires</LABEL>
			<LABEL>@post</LABEL>
			<LABEL>@ensures</LABEL>
			<LABEL>@generates</LABEL>
			<LABEL>@modifies</LABEL>
			<LABEL>@invariant</LABEL>
			<LABEL>@exception</LABEL>
			<LABEL>@hides</LABEL>
			<LABEL>@overrides</LABEL>
			<LABEL>@equivalent</LABEL>
			<LABEL>@bon</LABEL>
			<LABEL>@access</LABEL>
			<LABEL>@example</LABEL>
			<LABEL>@design</LABEL>
			<LABEL>@serial</LABEL>
			<LABEL>@references</LABEL>
			<LABEL>@uses</LABEL>
			<LABEL>@guard</LABEL>
			<LABEL>@values</LABEL>
			<LABEL>@complexity</LABEL>
			<LABEL>@deprecated</LABEL>
			<LABEL>@docRoot</LABEL>
			<LABEL>@exception</LABEL>
			<LABEL>@link</LABEL>
			<LABEL>@param</LABEL>
			<LABEL>@return</LABEL>
			<LABEL>@see</LABEL>
			<LABEL>@serialData</LABEL>
			<LABEL>@serialField</LABEL>
			<LABEL>@since</LABEL>
			<LABEL>@throws</LABEL>
			<LABEL>@version</LABEL>
			<LABEL>@spec</LABEL>
		</KEYWORDS>
	</RULES>
</MODE>
